#include "simulators-common.h"

using namespace IDSIA;

class NetworkApplication 
{
  public:

  NetworkApplication() {};

  void InitSocketWithRobotApplication(SInt32 _id, int port_base, int _max_content_size = MAX_MSG_SIZE);
  void GetStartInfoFromRobotAppl();
  vector<string> GetNewInputDataFromRobotApp(Real current_time_slice, int num_robots);
  void ReceiveData(Real current_time_slice);
  void SendReceivedDataToRobotApp(Real current_time_slice, int from, string content);
  inline Socket GetSocket() { return socket; }

  protected:

  Socket socket;
  SInt32 id;

  RobotStartPacket   msg_start;
  ApplicationPacket  msg_header;
  char              *msg_content;
  int                msg_size;
  int                max_content_size;
  char              *received_data;

};

