/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 UCM
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author:  Delfín Rupérez Cañas <delfinrc@fdi.ucm.es>
 *          
 */

#include "antor-dlr-helper.h"
#include "ns3/antor-dlr-core.h"
#include "ns3/node-list.h"
#include "ns3/names.h"
#include "ns3/ipv4-list-routing.h"

namespace ns3 {

AntORDLRHelper::AntORDLRHelper ()
{
  m_agentFactory.SetTypeId ("ns3::antordlr::AntORDLRCore");
}

AntORDLRHelper*
AntORDLRHelper::Copy (void) const
{
  return new AntORDLRHelper (*this);
}


Ptr<Ipv4RoutingProtocol> 
AntORDLRHelper::Create (Ptr<Node> node) const
{
  Ptr<antordlr::AntORDLRCore> agent = m_agentFactory.Create<antordlr::AntORDLRCore> ();
  node->AggregateObject (agent);
  return agent;
}

void 
AntORDLRHelper::Set (std::string name, const AttributeValue &value)
{
  m_agentFactory.Set (name, value);
}

} // namespace ns3
