/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 UCM
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author:  Delfín Rupérez Cañas <delfinrc@fdi.ucm.es>
 *          
 */
#include "antor-dlr-heuristic.h"

namespace ns3 {

namespace antordlr {

double AntORHeuristic::GetRandom(){
double r = UniformVariable().GetValue (0,  1);
//double r = (   (double)rand() / ((double)(RAND_MAX)+(double)(1)) );
//std::cout << r << std::endl;
return r;
}

uint32_t AntORHeuristic::CalculateReactiveNextHop(std::vector<RoutingTableEntry> routes, double parameter) {

//FIXME
	 double val = GetRandom();

	    uint32_t m_nextHop = 0;
	    std::vector<double> ranks;
	    double sumPhero = 0.0;

	    //ranks.push_back(0.0);
	    for (uint32_t k = 0; k < routes.size(); k++) {
	     sumPhero = sumPhero + pow(routes[k].GetPheroTable().pheroReg,parameter);
	    }



	    for (uint32_t i = 0; i < routes.size(); i++) {

	    	if (i != 0){
	    		ranks.push_back(ranks[i-1] + pow(routes[i].GetPheroTable().pheroReg,parameter)/sumPhero);
	    	}else {
	    		//
	    		ranks.push_back( pow(routes[i].GetPheroTable().pheroReg,parameter)/sumPhero);
	    	}

	    	//sumPhero = sumPhero + pow(routes[i].GetPheroTable().pheroReg,parameter);
	     }
	ranks.insert(ranks.begin(),0.0);
	    for (uint32_t j = 0; j < ranks.size() - 1 ; j++) {
	  //std::cout  << pow (routes[j]._pheroTable.pheroReg,parameter) / sumPhero << " " << val << std::endl;

	    	if (val >= ranks[j] && val < ranks[j+1])
	         m_nextHop = j;


	    }
	   return m_nextHop;
/*

    double val = GetRandom();

    double sumPhero = 0.0;
    uint32_t m_nextHop = 0;
    for (uint32_t i = 0; i < routes.size(); i++) {
           sumPhero = sumPhero + pow(routes[i].GetPheroTable().pheroReg,parameter);
     }

    for (uint32_t j = 0; j < routes.size() ; j++) {
  //std::cout  << pow (routes[j]._pheroTable.pheroReg,parameter) / sumPhero << " " << val << std::endl;
   if (  ( pow (routes[j].GetPheroTable().pheroReg,parameter) / (double) sumPhero) > val ){
                m_nextHop = j;
          }

       }
   return m_nextHop;
*/
}

uint32_t AntORHeuristic::CalculateProactiveNextHop(std::vector<RoutingTableEntry> routes, double parameter) {


	double val = GetRandom();

	//std::cout << "NUM ROUTES : "<<routes.size() <<"\n";
	      uint32_t m_nextHop = 0;
	      std::vector<double> ranks;
	      //ranks.push_back(0.0);

	      double sumPhero = 0.0;
	      double valormax = 0.0;
	      for (uint32_t k = 0; k < routes.size(); k++) {
	          valormax = std::max(routes[k].GetPheroTable().pheroReg,routes[k].GetPheroTable().pheroVir);
	    	  sumPhero = sumPhero + pow(valormax,parameter);
	          //ranks.push_back(0.0);
	      }



	      for (uint32_t i = 0; i < routes.size(); i++) {
	    	  valormax = std::max(routes[i].GetPheroTable().pheroReg,routes[i].GetPheroTable().pheroVir);


	    		if (i != 0){
	    	    		ranks.push_back(ranks[i-1] + (pow(valormax,parameter)/sumPhero));
	    	    	}else {
	    	            //ranks.push_back(0.0);
	    	    		ranks.push_back( pow(valormax,parameter)/sumPhero);
	    	    	}

	      	//sumPhero = sumPhero + pow(routes[i].GetPheroTable().pheroReg,parameter);
	       }
	      ranks.insert(ranks.begin(),0.0);
	      for (uint32_t j = 0; j < ranks.size() - 1 ; j++) {
	       //std::cout  << val <<" -- " << ranks[j+1]<<"\n";
	     	if (val >= ranks[j] && val < ranks[j+1]){
	           m_nextHop = j;
	        }
	      }

	     //std::cout << m_nextHop << "\n";
	     return m_nextHop;
/*

//FIXME

	double val = GetRandom();
    double sumPhero = 0.0;
    uint32_t m_nextHop = 0;
    for (uint32_t i = 0; i < routes.size(); i++) {
        double valormax = (routes[i].GetPheroTable().pheroReg > 0.0 ? routes[i].GetPheroTable().pheroReg : routes[i].GetPheroTable().pheroVir);
        sumPhero = sumPhero + pow(valormax,parameter);

    }

    for (uint32_t j = 0; j < routes.size() ; j++) {
      double valormax2 = (routes[j].GetPheroTable().pheroReg > 0.0 ? routes[j].GetPheroTable().pheroReg : routes[j].GetPheroTable().pheroVir);
     // std::cout << pow (valormax2,parameter) / sumPhero << " " << val << std::endl;
 if ( ( pow (valormax2,parameter) / (double) sumPhero) > val ){
                m_nextHop = j;

       }
    }
return m_nextHop;
*/
}


double AntORHeuristic::CalculateNewPheroReg(double oldPheroReg, double parameter, Time cost) {

    double m_pheroReg = (parameter * oldPheroReg) +  ((1.0 - parameter) *  ( 1.0 / cost.GetSeconds()) );
   return m_pheroReg;
}


double AntORHeuristic::CalculateDifussionPhero(double best, Time cost) {

   double m_pheroVir =  1.0 / ( ( 1.0 / best)  + cost.GetSeconds() ) ;
   return m_pheroVir;

}
double AntORHeuristic::CalculateNewNumAvgHop(double oldnumAvgHop,double parameter,uint32_t hops) {

    double m_numAvgHop = (parameter * oldnumAvgHop) + ( (1.0 - parameter) * hops );
   return m_numAvgHop;
}

}

} // namespace ns3
