/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 UCM
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author:  Delfín Rupérez Cañas <delfinrc@fdi.ucm.es>
 *          
 */


#ifndef ANTOR_HEURISTIC_H_
#define ANTOR_HEURISTIC_H_

#include "ns3/nstime.h"
#include "ns3/random-variable.h"
#include "ns3/antor-dlr-routing-table.h"

#define parameter_beta1 20.0   // Reactive Process
#define parameter_beta2 2.0    // Proactive Process
#define parameter_beta3 20.0    // Data Routing

#define parameter_alpha 0.7  //
#define parameter_gamma 0.7


namespace ns3 {

namespace antordlr {

class AntORHeuristic {


public:

    AntORHeuristic() {}

    ~AntORHeuristic() {}

    uint32_t CalculateReactiveNextHop(std::vector<RoutingTableEntry> routes, double parameter);

    uint32_t CalculateProactiveNextHop(std::vector<RoutingTableEntry> routes, double parameter);

    double CalculateDifussionPhero(double best, Time cost);

    double CalculateNewPheroReg(double oldPheroReg, double parameter, Time cost);


    double CalculateNewNumAvgHop(double oldnumAvgHop,double parameter,uint32_t hops);

private: 

 double GetRandom();


};

}

} // namespace ns3

#endif /* ANTOR_HEURISTIC_H_ */


